// ReggieDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Reggie.h"
#include "ReggieDlg.h"

extern "C"
{
#include "XPEPM.h"
}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReggieDlg dialog

CReggieDlg::CReggieDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReggieDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReggieDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReggieDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReggieDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReggieDlg, CDialog)
	//{{AFX_MSG_MAP(CReggieDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_BN_CLICKED(IDC_SHUTDOWN, OnShutdown)
	ON_BN_CLICKED(IDC_REBOOT, OnReboot)
	ON_BN_CLICKED(IDC_Standby, OnStandby)
	ON_BN_CLICKED(IDC_Hibernation, OnHibernation)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReggieDlg message handlers

BOOL CReggieDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	OnRefresh();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CReggieDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReggieDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReggieDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CReggieDlg::OnRefresh() 
{
	// TODO: Add your control notification handler code here
	//Read the value from the registry otherwise an error is displayed via the static text
	HKEY hkey;
    TCHAR szBuf[132]; 
	DWORD dwSize;
	DWORD dwType;
	DWORD dwRet;
    dwRet = RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\A7\\Reggie"),
			0, NULL, 0, KEY_ALL_ACCESS, NULL, &hkey, NULL);

	if(dwRet == ERROR_SUCCESS)
	{
		dwType = REG_SZ;

		dwSize = sizeof(szBuf);

		if(RegQueryValueEx(hkey, TEXT("CD_Data"), NULL, &dwType,
				(PBYTE)szBuf, &dwSize) == ERROR_SUCCESS)
		{
			SetDlgItemText(IDC_VALUEIS, szBuf);
		}

	    dwRet = RegCloseKey(hkey);
	}
}

void CReggieDlg::OnSet() 
{
	// TODO: Add your control notification handler code here
	HKEY	hkey;
	TCHAR szBuf[132];

	DWORD dwType, dwSize;
	DWORD dwRet;

	dwRet = RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\A7\\Reggie"),
			0, NULL, 0, KEY_ALL_ACCESS, NULL, &hkey, NULL);
	if(dwRet == ERROR_SUCCESS)
	{
		dwType = REG_SZ;
		GetDlgItemText(IDC_SETSTRING, szBuf, sizeof(szBuf));
		dwSize = 
			(_tcslen(szBuf) + 1) * sizeof(TCHAR);
		dwRet = RegSetValueEx(hkey, TEXT("CD_Data"), 0, dwType, 
			(PBYTE)&szBuf, dwSize);

		dwRet = RegCloseKey(hkey);
	}
	OnRefresh();

}

void CReggieDlg::OnShutdown() 
{
	// TODO: Add your control notification handler code here
	XPE_Shutdown( );
	
}

void CReggieDlg::OnReboot() 
{
	// TODO: Add your control notification handler code here
	XPE_ReStart( );

	
}

void CReggieDlg::OnStandby() 
{
	// TODO: Add your control notification handler code here
	XPE_StandBy(1);
	
}

void CReggieDlg::OnHibernation() 
{
	// TODO: Add your control notification handler code here
	XPE_Hibernate(1);
	
}
